% Load a maze-like map...
% load map1.mat
% ...or some simple shapes
im = imread('problem1.png');
imgray = rgb2gray(im);
imbw = imbinarize(imgray);
map = double(imbw);
figure(1);
spy(map);

% Expand obstacles with dilation
% Useful when the target itself has some size to it
obj = strel('disk', 30, 8); % structuring element
dilated_map = double(imdilate(imbw, obj));
figure(2);
spy(dilated_map);

start = [100, 400];
goal = [500, 100];

%% PRM

prm = PRM(dilated_map);
prm.plan();
path = prm.query(start, goal);

figure(3);
prm.plot();

%% D-STAR (discretisation method)

% ds = Dstar(dilated_map);
% c = ds.costmap();
% 
% ds.plan(goal);
% path = ds.query(start);
% 
% figure(3);
% ds.plot();
% hold on;
% plot(path(:, 1), path(:, 2))

